#include<bits/stdc++.h>
#define lli long long
#define endl "\n"
using namespace std;
const lli MAXN=2005;
pair<lli, lli> start, fin;
lli N, M, dist[MAXN][MAXN];
bool used[MAXN][MAXN];
queue<pair<lli, lli>> q;
char c;
bool dfs(lli x, lli y, lli z){
    if(x==fin.first and y==fin.second)return 1;
    if(dist[x][y]<z)return 0;
    used[x][y]=1;
    if(x+1!=N and !used[x+1][y]){
        if(dfs(x+1, y, z))return 1;
    }
    if(x-1>=0 and !used[x-1][y]){
        if(dfs(x-1, y, z))return 1;
    }
    if(y+1!=M and !used[x][y+1]){
        if(dfs(x, y+1, z))return 1;
    }
    if(y-1>=0 and !used[x][y-1]){
        if(dfs(x, y-1, z))return 1;
    }
    return 0;
}
bool proverka(lli x){
    memset(used, 0, sizeof(used));
    return dfs(start.first, start.second, x);
}
lli bin_search(lli l, lli r){
    lli mid=0;
    while(l!=r-1){
        mid=(l+r)/2;
        if(proverka(mid))l=mid;
        else r=mid;
    }
    if(proverka(r))return r;
    return l;
}
int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    cin>>N>>M;
    memset(dist, 999999, sizeof(dist));
    for(lli i=0; i<N; i++){
        for(lli j=0; j<M; j++){
            cin>>c;
            if(c=='P')start={i, j};
            else if(c=='C')fin={i, j};
            else if(c=='+'){
                q.push({i, j});
                dist[i][j]=0;
            }
        }
    }
    while(!q.empty()){
        lli x=q.front().first, y=q.front().second;
        q.pop();
        if(used[x][y])continue;
        used[x][y]=1;
        if(x+1!=N and dist[x+1][y]>dist[x][y]+1){
            dist[x+1][y]=dist[x][y]+1;
            q.push({x+1, y});
        }
        if(x-1>=0 and dist[x-1][y]>dist[x][y]+1){
            dist[x-1][y]=dist[x][y]+1;
            q.push({x-1, y});
        }
        if(y+1!=M and dist[x][y+1]>dist[x][y]+1){
            dist[x][y+1]=dist[x][y]+1;
            q.push({x, y+1});
        }
        if(y-1>=0 and dist[x][y-1]>dist[x][y]+1){
            dist[x][y-1]=dist[x][y]+1;
            q.push({x, y-1});
        }
    }
    cout<<bin_search(0, 4001)<<endl;
    return 0;
}
/*
6 5
P....
.....
.....
.....
++...
....C
*/
