#include<bits/stdc++.h>
using namespace std;

int const MAXN=2001, inf = 1e9;
int n, m, path[MAXN][MAXN], used[MAXN][MAXN];
char ch;

struct edge
{
    int x, y;
};

vector<edge> v;
edge p, c;

void fill_matrix(int row, int col, int val)
{
    path[row][col] = val;
    if(row < n && path[row+1][col] > val + 1)
    {
        fill_matrix(row+1, col, val+1);
    }
    if(col < m && path[row][col+1] > val + 1)
    {
        fill_matrix(row, col+1, val+1);
    }
    if(row > 1 && path[row-1][col] > val + 1)
    {
        fill_matrix(row-1, col, val+1);
    }
    if(col > 1 && path[row][col-1] > val + 1)
    {
        fill_matrix(row, col-1, val+1);
    }
}

void solution(int row, int col, int val)
{
    //cout<<row<<" "<<col<<" "<<val<<endl;
    used[row][col] = 1;
    if(row == c.x && col == c.y)
    {
        cout<<val<<endl;
        exit(0);
    }
    if(!used[row+1][col] && row < n && path[row+1][col] >= val)
    {
        solution(row+1, col, val);
    }
    if(!used[row][col+1] && col < m && path[row][col+1] >= val)
    {
        solution(row, col+1, val);
    }
    if(!used[row-1][col] && row > 1 && path[row-1][col] >= val)
    {
        solution(row-1, col, val);
    }
    if(!used[row][col-1] && col > 1 && path[row][col-1] >= val)
    {
        solution(row, col-1, val);
    }
}

void read()
{

    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            cin>>ch;
            if(ch == '+')  v.push_back({i, j});
            else if(ch == 'P') p = {i, j};
            else if(ch == 'C') c = {i, j};
        }
    }
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            path[i][j] = inf;
        }
    }
    for(int i=0;i<v.size();i++)
    {
        fill_matrix(v[i].x, v[i].y, 0);
    }
    for(int u=path[p.x][p.y];u>=0;u--)
    {
        solution(p.x, p.y, u);
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=m;j++)
            {
                used[i][j] = 0;
            }
        }
    }
}

int main()
{
    read();
    return 0;
}
