#include<bits/stdc++.h>
using namespace std;
const int maxn = 2002;
struct cell
{
    int x;
    int y;
    cell() {};
    cell( int x1, int y1 )
    {
        x = x1;
        y = y1;
    }
    cell add( cell tc )
    {
        cell ans;
        ans.x = x + tc.x;
        ans.y = y + tc.y;
        return ans;
    }
};
int n,m;
int a[maxn][maxn];
int raz[maxn][maxn];
cell tadd[4] {{1,0},{0,1},{-1,0},{0,-1}};
cell from;
cell to;
int used[maxn][maxn];
int dist = 0;
void read()
{
    cin >> n >> m;
    for( int i = 1; i <= n; i ++ )
    {
        for( int j = 1; j <= m; j ++ )
        {
            char tc;
            cin >> tc;
            if( tc == '+' ) a[i][j] = 1;
            else if( tc == 'P' )
            {
                from.x = i;
                from.y = j;
            }
            else if( tc == 'C' )
            {
                to.x = i;
                to.y = j;
            }
        }
    }
}
bool is_valid( cell w )
{
    if( w.x >= 1 && w.x <= n && w.y >= 1 && w.y <= m ) return 1;
    else return 0;
}
void bfs()
{
    queue<cell>q;
    for( int i = 1; i <= n; i ++ )
    {
        for( int j = 1; j <= m; j ++ )
        {
            if( a[i][j] == 1 )
            {
                cell tc(i,j);
                q.push(tc);
                raz[i][j] = 1;
            }
        }
    }

    while( !q.empty() )
    {
        cell w = q.front();
        q.pop();
        for( int i = 0; i < 4; i ++ )
        {
            cell nb = w.add(tadd[i]);
            if( is_valid(nb) == 1 && raz[nb.x][nb.y] == 0 )
            {
                raz[nb.x][nb.y] = raz[w.x][w.y] + 1;
                q.push(nb);
            }
        }
    }
}
void dfs( cell w )
{
    used[w.x][w.y] = 1;
    for( int i = 0; i < 4; i ++ )
    {
        cell nb = w.add(tadd[i]);
        if( is_valid(nb) == 1 && used[nb.x][nb.y] == 0 && raz[nb.x][nb.y] >= dist ) dfs(nb);
    }
}
void bin_search()
{
    int l = 0;
    int r = n + m - 1;
    int last_ans = 0;
    while( l <= r )
    {
        int m = ( l + r ) / 2;
        dist = m;
        memset(used,0,sizeof(used));
        dfs(from);
        if( used[to.x][to.y] == 1 )
        {
            l = m + 1;
            last_ans = dist - 1;
        }
        else r = m - 1;
    }
    cout << last_ans << endl;
}
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int main()
{
    speed();
    read();
    bfs();
    bin_search();
    return 0;
}
