#include<bits/stdc++.h>
using namespace std;
const long long maxn = 2002;
struct cell
{
    long long x;
    long long y;
    cell() {};
    cell( long long x1, long long y1 )
    {
        x = x1;
        y = y1;
    }
    cell add( cell tc )
    {
        cell ans;
        ans.x = x + tc.x;
        ans.y = y + tc.y;
        return ans;
    }
};
long long n,m;
long long a[maxn][maxn];
long long raz[maxn][maxn];
long long used[maxn][maxn];
cell tadd[4] {{1,0},{0,1},{-1,0},{0,-1}};
long long dist = 0;
cell from;
cell to;
queue<cell>q;
void read()
{
    cin >> n >> m;
    for( long long i = 1; i <= n; i ++ )
    {
        for( long long j = 1; j <= m; j ++ )
        {
            char tc;
            cin >> tc;
            if( tc == '+' )
            {
                a[i][j] = 1;
                cell tc(i,j);
                q.push(tc);
                raz[i][j] = 1;
            }
            else if( tc == 'P' )
            {
                from.x = i;
                from.y = j;
            }
            else if( tc == 'C' )
            {
                to.x = i;
                to.y = j;
            }
        }
    }
}
bool is_valid( cell w )
{
    if( w.x >= 1 && w.x <= n && w.y >= 1 && w.y <= m ) return 1;
    else return 0;
}
void bfs()
{
    while( !q.empty() )
    {
        cell w = q.front();
        q.pop();
        for( long long i = 0; i < 4; i ++ )
        {
            cell nb = w.add(tadd[i]);
            if( is_valid(nb) == 1 && raz[nb.x][nb.y] == 0 )
            {
                raz[nb.x][nb.y] = raz[w.x][w.y] + 1;
                q.push(nb);
            }
        }
    }
}
void dfs( cell w )
{
    used[w.x][w.y] = 1;
    for( long long i = 0; i < 4; i ++ )
    {
        cell nb = w.add(tadd[i]);
        if( is_valid(nb) == 1 && used[nb.x][nb.y] == 0 )
        {
            if( nb.x == from.x && nb.y == from.y ) dfs(nb);
            else if( nb.x == to.x && nb.y == from.y ) dfs(nb);
            else if( raz[nb.x][nb.y] - 1 >= dist )
            {
                dfs(nb);
            }
        }
    }
}
void bin_search()
{
    long long l = 1;
    long long r = n + m - 1;
    long long last_ans = n + m - 1;
    while( l <= r )
    {
        //cout << l << " "<< r << endl;
        dist = ( l + r ) / 2;
        memset(used,0,sizeof(used));
        dfs(from);
        if( used[to.x][to.y] == 1 )
        {
            l = dist + 1;
            last_ans = dist;
            last_ans = min( last_ans , raz[to.x][to.y]);
            last_ans = min( last_ans , raz[from.x][from.y]);
        }
        else r = dist - 1;
    }
    cout << last_ans << '\n';
}
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int main()
{
    speed();
    read();
    bfs();
    //for( long long i = 1; i <= n; i ++ )
    //{
    // for( long long j = 1; j <= m; j ++ )
    // {
    //  cout << raz[i][j] << " " ;
    // }
    // cout << endl;
    // }
    bin_search();
    return 0;
}
