#include<bits/stdc++.h>
using namespace std;
const int maxn = 100001;
int tree1[maxn*4];
int tree2[maxn*4];
void update1( int i, int l, int r, int pos, int x )
{
    if( l == r )
    {
        if( tree1[i] == 999999 ) tree1[i] = x;
        return;
    }
    int m = ( l + r ) / 2;
    if( pos <= m ) update1(i*2,l,m,pos,x);
    else update1(i*2+1,m+1,r,pos,x);

    tree1[i] = min( tree1[i*2] , tree1[i*2+1] );
    return;
}
int query1( int i, int l, int r, int ql, int qr )
{
    if( l == ql && r == qr ) return tree1[i];
    int m = ( l + r )  / 2;
    if( qr <= m ) return query1(i*2,l,m,ql,qr);
    else if( ql > m ) return query1(i*2+1,m+1,r,ql,qr);
    else return min( query1(i*2,l,m,ql,m) , query1(i*2+1,m+1,r,m+1,qr) );
}
void update2( int i, int l, int r, int pos, int x )
{
    if( l == r )
    {
        if( tree2[i] == 0 ) tree2[i] = x;
        return;
    }
    int m = ( l + r ) / 2;
    if( pos <= m ) update2(i*2,l,m,pos,x);
    else update2(i*2+1,m+1,r,pos,x);

    tree2[i] = max( tree2[i*2] , tree2[i*2+1] );
    return;
}
int query2( int i, int l, int r, int ql, int qr )
{
    if( l == ql && r == qr ) return tree2[i];
    int m = ( l + r )  / 2;
    if( qr <= m ) return query2(i*2,l,m,ql,qr);
    else if( ql > m ) return query2(i*2+1,m+1,r,ql,qr);
    else return max( query2(i*2,l,m,ql,m) , query2(i*2+1,m+1,r,m+1,qr) );
}
int ans[maxn];
vector <int> calc (int N, vector <int>& h, vector <int>& c)
{
    for( int i = 0; i < maxn*4; i ++ )
        tree1[i] = 999999;

    for( int i = 0; i < N; i ++ )
    {
        int x = query1(1,0,100000,0,h[i]);
        if( x == 999999 ) ans[i] = 0;
        else ans[i] = x;

        update1(1,0,100000,h[i],i+1);
    }


    for( int i = N-1; i >= 0 ; i -- )
    {
        int x = query2(1,0,100000,0,h[i]);
        //cout << i << " " << x << " " << h[i]  << endl;
        if( x != 0 )
        {
            if( ans[i] == 0 ) ans[i] = x;
            else if( abs(i-x) > abs(i-ans[i]) )
            {
                ans[i] = x;
            }
        }

        update2(1,0,100000,h[i],i+1);
    }

    vector<int>ansv;
    for( int i = 1; i <= N; i ++ )
      ansv.push_back(ans[i-1]);
  return ansv;
}