#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int maxn = 2048;
int n, m, sx, sy, ex, ey, used[maxn][maxn], cnt = 0, ans[maxn][maxn], lvl[maxn][maxn];
vector <pair <int, int>> v;

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;

    char c;
    for (int i=1; i<=n; ++i)
    {
        for (int j=1; j<=m; ++j)
        {
            cin >> c ;
            if (c == 'P') sx = i, sy = j;
            else if (c == 'C') ex = i, ey = j;
            if (c == '+')
            {
                v.push_back({i,j});
                ++ cnt;
            }
        }
    }
}

void BFS1()
{
    queue <pair<int, int>> q;
    for (int i=0; i<cnt; ++i)
    {
        used[v[i].first][v[i].second] = 1;
        q.push({v[i].first, v[i].second});
    }

    pair <int, int> p;
    int nx, ny;
    while (!q.empty())
    {
        p = {q.front().first, q.front().second};
        q.pop();
        nx = p.first;
        ny = p.second-1;
        if (ny > 0)
        {
            if (!used[nx][ny])
            {
                used[nx][ny] = used[p.first][p.second] + 1;
                q.push({nx,ny});
            }
        }
        ny += 2;
        if (ny <= m)
        {
            if (!used[nx][ny])
            {
                used[nx][ny] = used[p.first][p.second] + 1;
                q.push({nx,ny});
            }
        }
        -- ny;
        -- nx;
        if (nx > 0)
        {
            if (!used[nx][ny])
            {
                used[nx][ny] = used[p.first][p.second] + 1;
                q.push({nx,ny});
            }
        }
        nx += 2;
        if (nx <= n)
        {
            if (!used[nx][ny])
            {
                used[nx][ny] = used[p.first][p.second] + 1;
                q.push({nx,ny});
            }
        }
    }
}

void BFS2()
{
    queue <pair<int, int>> q;
    q.push({sx, sy});

    pair <int, int> p;
    int nx, ny, nbx, nby;
    while (!q.empty())
    {
        p = {q.front().first, q.front().second};
        q.pop();
        nx = p.first;
        ny = p.second-1;
        if (ny > 0)
        {
            if (!lvl[nx][ny])
            {
                lvl[nx][ny] = lvl[p.first][p.second] + 1;
                int res = 0;
                nbx = nx;
                nby = ny-1;
                if (nby > 0)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                nby += 2;
                if (nby <= m)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                -- nby;
                -- nbx;
                if (nbx > 0)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                nbx += 2;
                if (nbx <= n)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                if (res == 0) ans[nx][ny] = used[nx][ny];
                else ans[nx][ny] = min(used[nx][ny], res);
                q.push({nx,ny});
            }
        }
        ny += 2;
        if (ny <= m)
        {
            if (!lvl[nx][ny])
            {
                lvl[nx][ny] = lvl[p.first][p.second] + 1;
                int res = 0;
                nbx = nx;
                nby = ny-1;
                if (nby > 0)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                nby += 2;
                if (nby <= m)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                -- nby;
                -- nbx;
                if (nbx > 0)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                nbx += 2;
                if (nbx <= n)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                if (res == 0) ans[nx][ny] = used[nx][ny];
                else ans[nx][ny] = min(used[nx][ny], res);
                q.push({nx,ny});
            }
        }
        -- ny;
        -- nx;
        if (nx > 0)
        {
            if (!lvl[nx][ny])
            {
                lvl[nx][ny] = lvl[p.first][p.second] + 1;
                int res = 0;
                nbx = nx;
                nby = ny-1;
                if (nby > 0)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                nby += 2;
                if (nby <= m)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                -- nby;
                -- nbx;
                if (nbx > 0)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                nbx += 2;
                if (nbx <= n)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                if (res == 0) ans[nx][ny] = used[nx][ny];
                else ans[nx][ny] = min(used[nx][ny], res);
                q.push({nx,ny});
            }
        }
        nx += 2;
        if (nx <= n)
        {
            if (!lvl[nx][ny])
            {
                lvl[nx][ny] = lvl[p.first][p.second] + 1;
                int res = 0;
                nbx = nx;
                nby = ny-1;
                if (nby > 0)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                nby += 2;
                if (nby <= m)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                -- nby;
                -- nbx;
                if (nbx > 0)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                nbx += 2;
                if (nbx <= n)
                {
                    if (res < ans[nbx][nby]) res = ans[nbx][nby];
                }
                if (res == 0) ans[nx][ny] = used[nx][ny];
                else ans[nx][ny] = min(used[nx][ny], res);
                q.push({nx,ny});
            }
        }
    }
}

void solve()
{
    BFS1();
    /*for (int i=1; i<=n; ++i)
    {
        for (int j=1; j<=m; ++j)
        {
            cout << used[i][j] << " " ;
        }
        cout << endl;
    }*/

    BFS2();
    /*for (int i=1; i<=n; ++i)
    {
        for (int j=1; j<=m; ++j)
        {
            cout << ans[i][j] << " " ;
        }
        cout << endl;
    }*/

    cout << ans[ex][ey]-1 << endl;
}

int main()
{
    read();
    solve();
    return 0;
}