#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int maxn = 1e6+2;
struct tree
{
    int x;
    int y;
    int idx;
};
tree a[maxn];
int ans[maxn];

bool cmp(tree a1, tree a2)
{
    if (a1.x < a2.x) return true;
    if (a1.x > a2.x) return false;
    if (a1.y < a2.y) return true;
    if (a1.y > a2.y) return false;
    return (a1.idx < a2.idx);
}

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

vector <int> calc (int N, vector <int>& h, vector <int>& c)
{
    speed();
    for (int i=1; i<=N; ++i)
    {
        a[i] = {h[i-1], c[i-1], i};
    }
    sort(a+1, a+N+1, cmp);

    vector <int> v(N);
    if (a[1].x == a[2].x && a[1].y == a[2].y) ans[a[1].idx-1] = a[2].idx;
    else ans[a[1].idx-1] = 0;
    ans[a[2].idx-1] = a[1].idx;
    v[a[1].idx-1] = ans[a[1].idx-1];
    v[a[2].idx-1] = ans[a[2].idx-1];

    int i, j, l = 1, r = 2, k1, k2;
    for (i=3; i<=N; ++i)
    {
        //cout << i << ": " << a[i].x << " " << a[i].y << " " << a[i].idx << endl;
        bool lamp1 = false, lamp2 = false;
        k1 = a[i].idx - a[l].idx;
        k1 = k1 < 0 ? k1*(-1) : k1;
        k2 = a[i].idx - a[r].idx;
        k2 = k2 < 0 ? k2*(-1) : k2;
        if (k1 >= k2) ans[a[i].idx-1] = a[l].idx, lamp1 = true;
        if (k1 < k2) ans[a[i].idx-1] = a[r].idx, lamp2 = true;
        j = i-1;
        while (j > 0 && a[i].x == a[j].x && a[i].y == a[j].y)
        {
            //cout << i << " " << j << endl;
            //cout << abs(a[j].idx-ans[a[j].idx]) << " " << abs(a[j].idx-a[i].idx) << endl;
            k1 = a[j].idx-ans[a[j].idx-1];
            k1 = k1 < 0 ? k1*(-1) : k1;
            k2 = a[j].idx-a[i].idx;
            k2 = k2 < 0 ? k2*(-1) : k2;
            if (k1 < k2) ans[a[j].idx-1] = v[a[j].idx-1] = a[i].idx;
            if (k1 == k2) ans[a[j].idx-1] = v[a[j].idx-1] = ((a[i].idx < ans[a[j].idx-1]) ? a[i].idx : ans[a[j].idx-1]);
            if (lamp1)
            {
                k1 = a[j].idx-ans[a[j].idx-1];
                k1 = k1 < 0 ? k1*(-1) : k1;
                k2 = a[j].idx-a[l].idx;
                k2 = k2 < 0 ? k2*(-1) : k2;
                if (k1 < k2) ans[a[j].idx-1] = v[a[j].idx-1] = a[l].idx;
                if (k1 == k2) ans[a[j].idx-1] = v[a[j].idx-1] = ((a[l].idx < ans[a[j].idx-1]) ? a[l].idx : ans[a[j].idx-1]);
            }
            else
            {
                k1 = a[j].idx-ans[a[j].idx-1];
                k1 = k1 < 0 ? k1*(-1) : k1;
                k2 = a[j].idx-a[r].idx;
                k2 = k2 < 0 ? k2*(-1) : k2;
                if (k1 < k2) ans[a[j].idx-1] = v[a[j].idx-1] = a[r].idx;
                if (k1 == k2) ans[a[j].idx-1] = v[a[j].idx-1] = ((a[r].idx < ans[a[j].idx-1]) ? a[r].idx : ans[a[j].idx-1]);
            }
            -- j;
        }
        if (a[i].idx < a[l].idx) l = i;
        if (a[i].idx > a[r].idx) r = i;
        v[a[i].idx-1] = ans[a[i].idx-1];
    }

    /*v.push_back(0);
    for (int i=1; i<=N; ++i)
    {
        v.push_back(ans[i]);
    }*/
    return v;
}

/*
10
36 4
18 1
36 4
2 1
43 2
46 1
36 4
3 0
2 1
36 4
*/