#include <bits/stdc++.h>
using namespace std;
long long n, m, startx, starty, endx, endy, k=0;
int x[2048], y[2048], ans = 0;
char a[2001][2001];
int dist[2001][2001];
bool used[2001][2001];
void dfs(int px, int py, int currmin)
{
    if(px==endx&&py==endy)
    {
        ans = max(ans, currmin);
        return;
    }
    if(px<0||px>=n)return;
    if(py<0||py>=m) return;
    if(used[px][py]) return;
    used[px][py] = true;
    currmin = min(dist[px][py], currmin);
    if(px>0) dfs(px-1, py, currmin);
    if(px<n-1) dfs(px+1, py, currmin);
    if(py>0) dfs(px, py-1, currmin);
    if(py<m-1) dfs(px, py+1, currmin);
    used[px][py] = false;
    return;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m;
    for(int i=0; i<n; i++)
        for(int j=0; j<m; j++)
        {
            cin>>a[i][j];
            dist[i][j] = INT_MAX;
            if(a[i][j] == 'P') startx = i, starty = j;
            if(a[i][j] == 'C') endx = i, endy = j;
            if(a[i][j]== '+')
            {
                x[k] = i;
                y[k] = j;
                k++;
            }
        }

    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
                for(int z=0; z<k; z++)
                {
                    dist[i][j] = min(dist[i][j], abs(i-x[z])+abs(j-y[z]));
                }
        }
    }
    dfs(startx, starty, dist[startx][starty]);
    cout<<ans<<endl;
    return 0;
}

