#include<iostream>
#include<vector>
#include<queue>
#include<cstring>
#define endl '\n'
using namespace std;
long long n,m,d[2005][2005],dp[2005][2005],dp2[2005][2005];
bool b[2005][2005],b2[2005][2005];
char c;
long long pr,pc,cr,cc;
queue < pair< pair<long long,long long>, long long> > q;
long long ab(long long a)
{
    if(a<0) return -a;
    return a;
}
void dfs(long long r,long long c,long long ma)
{
    if(r<1 || c<1 || r>n || c>m || b2[r][c]) return;

    if(r==cr && c==cc)
        return;

    ma=min(ma,d[r][c]);

    if(dp[r][c]!=-1 && dp[r][c]>=ma) return;
    dp[r][c]=ma;


    b2[r][c]=1;


    for(long long i=-1;i<=1;i++)
    {
        for(long long j=-1;j<=1;j++)
        {
            if(i==0 && j==0 && ab(i)!=ab(j)) continue;

            dfs(r+i,c+j,ma);
        }
    }

    b2[r][c]=0;

}
void dfs2(long long r,long long c,long long ma)
{
    if(r<1 || c<1 || r>n || c>m || b2[r][c]) return;

    if(r==pr && c==pc)
        return;


    ma=min(ma,d[r][c]);

    if(dp2[r][c]!=-1 && dp2[r][c]>=ma) return;
    dp2[r][c]=ma;


    b2[r][c]=1;


    for(long long i=-1;i<=1;i++)
    {
        for(long long j=-1;j<=1;j++)
        {
            if(i==0 && j==0 && ab(i)!=ab(j)) continue;

            dfs2(r+i,c+j,ma);
        }
    }

    b2[r][c]=0;

}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;

    for(long long i=1;i<=n;i++)
    {
        for(long long j=1;j<=m;j++)
        {
            cin>>c;

            if(c=='P')
              {pr=i;pc=j;}

            if(c=='C')
              {cr=i;cc=j;}

            if(c=='+')
            {
                d[i][j]=1;
                q.push(make_pair(make_pair(i,j),1));
            }
        }
    }
    long long tr,tc,tt;
     while(!q.empty())
    {
        tr=q.front().first.first;tc=q.front().first.second;tt=q.front().second;
        q.pop();
        if( tr<1 || tc<1 || tr>n || tc>m || (d[tr][tc]>1 && d[tr][tc]<=tt) || (d[tr][tc]==1 && b[tr][tc])) continue;

        if(d[tr][tc]!=1)
        d[tr][tc]=tt;

        b[tr][tc]=1;

        for(long long i=-1;i<=1;i++)
        {
            for(long long j=-1;j<=1;j++)
            {
                if(i==0 && j==0) continue;

                q.push({{tr+i,tc+j},tt+ab(i)+ab(j)});
            }
        }
    }
    for(long long i=1;i<=n;i++)
    {
        for(long long j=1;j<=m;j++)
        {
            d[i][j]--;
            //cout<<d[i][j]-1<<" ";
        }//cout<<endl;
    }


    for(long long i=0;i<=n+1;i++)
        memset(dp[i],-1,sizeof(dp[i]));

    for(long long i=0;i<=n+1;i++)
        memset(dp2[i],-1,sizeof(dp2[i]));

    dfs(pr,pc,100000000000);
    dfs2(cr,cc,100000000000);


    long long maxi=0;
     for(long long i=1;i<=n;i++)
    {
        for(long long j=1;j<=m;j++)
        {
            maxi=max(maxi,min(dp[i][j],dp2[i][j]));
           // cout<<i<<" "<<j<<" "<<dp[i][j]<<" "<<dp2[i][j]<<endl;

        }
    }
    cout<<maxi<<endl;
}
/*
6 5
+...P
.....
..C..
...+.
++...
.....
*/
