#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int maxn = 1e6+2;
struct tree
{
    int x;
    int y;
    int idx;
};
tree a[maxn];
int ans[maxn];

bool cmp(tree a1, tree a2)
{
    if (a1.x < a2.x) return true;
    if (a1.x > a2.x) return false;
    if (a2.x < a2.x) return true;
    if (a2.x > a2.y) return false;
    return a1.idx < a2.idx;
}

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

vector <int> calc (int N, vector <int>& h, vector <int>& c)
{
    speed();
    for (int i=1; i<=N; ++i)
    {
        a[i] = {h[i], c[i], i};
    }
    sort(a+1, a+N+1, cmp);

    ans[a[1].idx] = 0;
    ans[a[2].idx] = a[1].idx;
    int l = 1, r = 2, k1, k2;
    for (int i=3; i<=N; ++i)
    {
        k1 = abs(a[i].idx - a[l].idx);
        k2 = abs(a[i].idx - a[r].idx);
        if (k1 >= k2) ans[a[i].idx] = a[l].idx;
        if (k1 < k2) ans[a[i].idx] = a[r].idx;
        if (a[i].idx < a[l].idx) l = i;
        if (a[i].idx > a[r].idx) r = i;
    }

    vector <int> v;
    for (int i=1; i<=N; ++i)
    {
        v.push_back(ans[i]);
    }
    return v;
}