#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int maxn = 1e6+2;
struct tree
{
    int x;
    int y;
    int idx;
};
tree a[maxn];
int ans[maxn];

bool cmp(tree a1, tree a2)
{
    if (a1.x < a2.x) return true;
    if (a1.x > a2.x) return false;
    if (a2.x < a2.x) return true;
    if (a2.x > a2.y) return false;
    return (a1.idx < a2.idx);
}

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

vector <int> calc (int N, vector <int>& h, vector <int>& c)
{
    speed();
    for (int i=1; i<=N; ++i)
    {
        a[i] = {h[i-1], c[i-1], i};
    }
    sort(a+1, a+N+1, cmp);

    vector <int> v(N+1);
    if (a[1].x == a[2].x && a[1].y == a[2].y) ans[a[1].idx] = a[2].idx;
    else ans[a[1].idx] = 0;
    ans[a[2].idx] = a[1].idx;
    v[a[1].idx] = ans[a[1].idx];
    v[a[2].idx] = ans[a[2].idx];

    int i, j, l = 1, r = 2, k1, k2;
    for (i=3; i<=N; ++i)
    {
        bool lamp1 = false, lamp2 = false;
        k1 = abs(a[i].idx - a[l].idx);
        k2 = abs(a[i].idx - a[r].idx);
        if (k1 >= k2) ans[a[i].idx] = a[l].idx, lamp1 = true;
        if (k1 < k2) ans[a[i].idx] = a[r].idx, lamp2 = true;
        j = i-1;
        while (a[a[i].idx].x == a[a[j].idx].x && a[a[i].idx].y == a[a[j].idx].y)
        {
            if (lamp1)
            {
                if (ans[a[j].idx] < abs(a[j].idx-a[l].idx)) v[a[j].idx] = abs(a[j].idx-a[r].idx);
            }
            else if (ans[a[j].idx] < abs(a[j].idx-a[r].idx)) v[a[j].idx] = abs(a[j].idx-a[r].idx);
            -- j;
        }
        if (a[i].idx < a[l].idx) l = i;
        if (a[i].idx > a[r].idx) r = i;
        v[a[i].idx] = ans[a[i].idx];
    }

    /*v.push_back(0);
    for (int i=1; i<=N; ++i)
    {
        v.push_back(ans[i]);
    }*/
    return v;
}